#
# $Id: simple.py,v 1.7 2006/05/19 23:50:35 mwalfish Exp $ 
#  
#  brain-dead way of managing disposables: on-disk list. 
#
#
# Copyright (C) 2005-2006 Michael Walfish
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
import os
import pickle
import random
import base

def create_new(quota,fname):
   
    sp = SimplePool(quota)
    sp.write_out(fname)
    return sp

def create_from_file(fname):
    """returns a SimplePool that is read from a file"""
    if os.path.exists(fname) is False: return None

    f = file(fname, 'rb')
    dpool = pickle.load(f)
    f.close()

    return dpool

class SimplePool(base.BasePool):

    def __eq__(self,other):
	return self.pool == other.pool and self.quota == other.quota

    def __init__(self,quota):
	
	base.BasePool.__init__(self,quota)
	self.pool = range(quota)
	self.quota = quota

    def write_out(self, fname):

	old_umask = os.umask(0077)
	f = file(fname, 'wb')

	pickle.dump(self, f)

	f.close()
	os.umask(old_umask)

    def num_left(self):

	return len(self.pool)

    def get_quota(self):

	return self.quota

    def consume_disposable(self):
	"""returns an integer selected randomly from those that remain. 
	Returns -1 if there are no more disposables left."""

	if len(self.pool) == 0: return -1
    
	r = random.randint(0, len(self.pool) - 1)
	ret = self.pool[r]
	del self.pool[r]

	return ret

