#!/bin/env python
#
# $Id: stamp-canceller.py,v 1.8 2006/05/19 23:50:35 mwalfish Exp $
#
# This program simply consumes (key,value) pairs from the set_queue and
# cancels them in the DQM.
#
# The pieces are in place for this to become asynchronous. Right now, for 
# debugging, we run the event loop synchronously.
#
# This program is rather hoopty, actually. There are a number of screwy
# things I need to fix. Sorry.
#
#
# Copyright (C) 2005-2006 Michael Walfish
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
import sys
import dqm.logger
import dqm.rpc.events   as dqm_events
import dqm.config.user  as dqm_config
import dqm.user.rcvr    as dqm_rcvr
import dqm.work_queue.q as work_q

global res_global
res_global = None

def consume_queue(dqm_client, set_q, logger):

    try:	
	while True:

	    key, val = set_q.dequeue()
	    logger.log("dequeued an item from the work queue")

	    ms = "this is a dummy metastamp"
	    dqm_client.set(key, val, ms, set_cb) 

	    # We invoke the event loop here because it prevents the
	    # rest of the code from having to become asynchronous. This is the
	    # equivalent of doing the call synchronously.
	    global res_global
	    res_global = None
	    dqm_events.loop(False)

	    assert(res_global is not None)
	    rc, err = res_global

	    if rc: msg = "successful communication with the DQM"
	    else:  msg = "'set' failed. err: %s" % err
	    logger.log(msg)

    except work_q.Error, errval:
	logger.log(str(errval)) 
	logger.log("leaving consume_queue. need to reinit database")



def set_cb(res):

    global res_global 
    res_global = res
    dqm_events.stop_looping()


if __name__ == "__main__":

    def usage():
	print """usage: %s config-file [log-file]""" % sys.argv[0]

    def usage_and_exit():
	usage()
	sys.exit(3)

    if len(sys.argv) not in [2, 3]:
	usage_and_exit()

    config_file = sys.argv[1]
    config_obj = dqm_config.parse_config(config_file)

    if len(sys.argv) == 2: logger = dqm.logger.stderr_logger()
    else:                  logger = dqm.logger.file_logger(sys.argv[2])

    dqm_client = dqm_rcvr.init_dqm(config_obj)

    logger.log("beginning . . .")
    while True:

	set_q = dqm_rcvr.init_set_q(config_obj['set_queue'], logger, 
				    custodian=True)
	consume_queue(dqm_client, set_q, logger)
	del set_q
