#!/usr/bin/perl
# 
# $Id: wrap-pycheck.pl,v 1.8 2005/03/16 00:37:39 mwalfish Exp $
#
# Gets the output of pychecker and ignores a class of spurious messages. If
# any other messages occur, this program returns a non-zero status code so 
# that 'make' will properly complain.
#


# add a -Q flag unless our caller already specified one
unshift(@ARGV, '-Q') unless join(" ", @ARGV) =~ m/-Q/;

$cmdargs = join(" ", @ARGV);

print "pychecker $cmdargs\n";

open(PYC_OUT, "pychecker $cmdargs 2>&1 |") or
    die "failed to run pychecker: $!";

$ignore1 = 'No module attribute \([^()]*\) found';
$ignore2 = 'couldn\'t find real module for class';
$ignore3 = ' -unknown-  | -unknown-  has no effect';

$err = 0;

while (<PYC_OUT>) {
   next if m/^\s*$/;
   # print out any lines emitted by pychecker that aren't spurious.
   # aside from the spurious lines, pychecker ought to be totally quiet.
   if (!m/$ignore1/ && !m/$ignore2/ && !m/$ignore3/) { print $_; $err = 1; }
}

exit $err
