#!/usr/bin/python
#
# Benchmark RSA and Rabin signing and verifying on different key sizes.
#
import os
import re

rabin_stem = "qa_rabin_"
rsa_stem = "qa_rsa_"
key_dir = "crypt-objects/"
gen_key = "./gen_key"

key_sizes = [1024, 1280, 1500, 1536, 2048]

def worker(prog, do_rsa, stem):

    for s in map(str, key_sizes):
	name = key_dir + stem + s

	if not os.path.exists(name):
	    cmd_array = [gen_key, '-b ' + s]

	    if (do_rsa): cmd_array.append('-r')

	    cmd_array.append(name)

	    cmd = ' '.join(cmd_array)
	    os.system(cmd)
	   
	
	cmd = prog + ' ' + name
	(a, out_err) = os.popen4(cmd, 'r')

	cmd_output = out_err.read().strip()
	r = re.match('min: (\S+)\.000$', cmd_output)
	print r.group(1) + '\t',


if __name__ == "__main__":

    progs = {"Verifying:":"bench/verify",
             "Signing:":"bench/sign"}

    for prog in progs.keys():
	
	print prog
	print '\t',
	for s in map(str,key_sizes):
	    print s + '\t',

	print
	print "Rabin: " + '\t',
	worker(progs[prog], False, rabin_stem)

	print
	print "RSA: " + '\t',
	worker(progs[prog], True, rsa_stem)
	print

	print
	print
