/*
 * Copyright (C) 2005-2006 Michael Walfish
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#ifndef _UTIL_H_
#define _UTIL_H_

#include "async.h"
#include "arpc.h"

ptr<asrv> init_udp_server(uint16_t port, const rpc_program& program, 
			  size_t sockbufsize = axprt::defps);
ptr<aclnt> init_udp_client(uint16_t port, const rpc_program& program);

// Recursively make all of the directories in the path. Returns 'false'
// on failure and 'true' on success.
bool makedirs(const char* path);

// random integer between a and b, inclusive
inline int get_rand_int(int a, int b)
{
    double rand_double = (rand() / (double)(RAND_MAX + 1.0));
    int scaled = (int)(((b+1)-a)*rand_double);
    int shifted = scaled + a;
    return shifted;
}

bool convertdouble(const char* cp, double* resp);


#endif
