/*
 * Copyright (C) 2005-2006 Michael Walfish
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
#include <stdio.h>
#include "calqueue.h"
#include "util.h"
#include <stdlib.h>
#include <assert.h>

#define ONE_MILLION 1000000
#define TEN_MILLION 10000000

struct foo {
    double when() { return w; }
    foo() : w(0.0) {}
    foo(int i) : w((double)i) {}
    double w;
};

int main(int argc, char** argv)
{
    CalQueue<foo> myq(ONE_MILLION, 10);

    for (int i = 0; i < ONE_MILLION; i++) {
	foo fo;
	fo.w = (double)unifRand(0, TEN_MILLION);
	myq.insert(fo);
    }

    foo last, curr;

    last = myq.inspect_min(0.0);
    last = myq.extract_min(last.when());
    curr = myq.inspect_min(last.when());
    curr = myq.extract_min(curr.when());

    int i = 0;

    while (curr.when() != 0.0) {

	if (curr.when() < last.when()) {
	    printf("i: %d. curr: %.2f. last: %.2f\n", i, 
		    curr.when(), last.when());
	    assert(0);
	}

	last = curr;
	curr = myq.extract_min(last.when());
	++i;
    }
}
